import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    kotlin("jvm") version "1.5.31"
    kotlin("plugin.serialization") version "1.5.31"
    // Linters and formatters
    id("org.jlleitschuh.gradle.ktlint") version "10.2.0"
    // For JitPack
    id("maven-publish")
}

group = "com.github.furetur"
version = "0.1.2"

repositories {
    mavenCentral()
    maven(url = "https://jitpack.io")
}

publishing {
    publications {
        create<MavenPublication>("maven") {
            groupId = "com.github.furetur"
            artifactId = "pratt"
            version = "0.1.2"

            from(components["java"])
        }
    }
}

dependencies {
    testImplementation("guru.zoroark.lixy:lixy-jvm:1849bb1")
    // JUnit 5
    testImplementation("org.junit.jupiter:junit-jupiter-engine:5.8.1")
    testImplementation("org.junit.jupiter:junit-jupiter-params:5.8.1")
    testImplementation("org.junit.jupiter:junit-jupiter-api:5.8.1")
    // Serialization
    testImplementation("org.jetbrains.kotlinx:kotlinx-serialization-json:1.3.0")
    testImplementation("com.charleskorn.kaml:kaml:0.36.0")
}

tasks.test {
    useJUnitPlatform()
}

tasks.withType<KotlinCompile>() {
    kotlinOptions.jvmTarget = "1.8"
}
